#include "type.h"

#define MAIN_Fosc        24000000UL

#define Timer0_Reload   (65536UL -(MAIN_Fosc / 1000))  //Timer 0 жƵ, 1000/

/*****************************************************************************/


/*************  س    **************/

#define PWM_PERIOD  1023    //ֵ

/*************  ر    **************/

bit B_1ms;          //1ms־

u16 PWM1_Duty=0;
u16 PWM2_Duty=256;
u16 PWM3_Duty=512;
u16 PWM4_Duty=1024;

bit PWM1_Flag=0;
bit PWM2_Flag=0;
bit PWM3_Flag=0;
bit PWM4_Flag=0;

void UpdatePwm(void);

/*********************  *************************/
void main(void)
{
    EAXFR = 1; //չĴ(XFR)ʹ
	
    P4M1 = 0x00;   
	  P4M0 = 0x00;    
    P6M1 = 0x00;  
   	P6M0 = 0x00;    
    
    //  Timer0ʼ
    AUXR = 0x80;    //Timer0 set as 1T, 16 bits timer auto-reload, 
    TH0 = (u8)(Timer0_Reload / 256);
    TL0 = (u8)(Timer0_Reload % 256);
    ET0 = 1;    //Timer0 interrupt enable
    TR0 = 1;    //Tiner0 run

    PWMA_CCER1 = 0x00; //д CCMRx ǰ CCxE رͨ
    PWMA_CCER2 = 0x00;
    PWMA_CCMR1 = 0x68; //ͨģʽ
    PWMA_CCMR2 = 0x68;
    PWMA_CCMR3 = 0x68;
    PWMA_CCMR4 = 0x68;
    PWMA_CCER1 = 0x55; //ͨʹܺͼ
    PWMA_CCER2 = 0x55;

    PWMA_ARRH = (u8)(PWM_PERIOD >> 8); //ʱ
    PWMA_ARRL = (u8)PWM_PERIOD;

    PWMA_ENO = 0xff; //ʹ

    PWMA_PS = 0xaa; //ѡ PWMͨ

    PWMA_BKR = 0x80;  //ʹ
    PWMA_CR1 |= 0x81; //ʹARRԤװ,ʼʱ

    P40 = 0;	//LED
    EA = 1;     //ж

    while (1);
}

/********************** Timer0 1msжϺ ************************/
void timer0(void) interrupt 1
{
    if(!PWM1_Flag)
    {
        PWM1_Duty++;
        if(PWM1_Duty > PWM_PERIOD) PWM1_Flag = 1;
    }
    else
    {
        PWM1_Duty--;
        if(PWM1_Duty <= 0) PWM1_Flag = 0;
    }

    if(!PWM2_Flag)
    {
        PWM2_Duty++;
        if(PWM2_Duty > PWM_PERIOD) PWM2_Flag = 1;
    }
    else
    {
        PWM2_Duty--;
        if(PWM2_Duty <= 0) PWM2_Flag = 0;
    }

    if(!PWM3_Flag)
    {
        PWM3_Duty++;
        if(PWM3_Duty > PWM_PERIOD) PWM3_Flag = 1;
    }
    else
    {
        PWM3_Duty--;
        if(PWM3_Duty <= 0) PWM3_Flag = 0;
    }

    if(!PWM4_Flag)
    {
        PWM4_Duty++;
        if(PWM4_Duty > PWM_PERIOD) PWM4_Flag = 1;
    }
    else
    {
        PWM4_Duty--;
        if(PWM4_Duty <= 0) PWM4_Flag = 0;
    }
    
    UpdatePwm();
}

//========================================================================
// : UpdatePwm(void)
// : PWMռձ. 
// : none.
// : none.
// 汾: V1.0, 2012-11-22
//========================================================================
void UpdatePwm(void)
{
    PWMA_CCR1H = (u8)(PWM1_Duty >> 8); //ռձʱ
    PWMA_CCR1L = (u8)(PWM1_Duty);
    PWMA_CCR2H = (u8)(PWM2_Duty >> 8); //ռձʱ
    PWMA_CCR2L = (u8)(PWM2_Duty);
    PWMA_CCR3H = (u8)(PWM3_Duty >> 8); //ռձʱ
    PWMA_CCR3L = (u8)(PWM3_Duty);
    PWMA_CCR4H = (u8)(PWM4_Duty >> 8); //ռձʱ
    PWMA_CCR4L = (u8)(PWM4_Duty);
}
