#include "uart.h"

bit	DmaFlag;

u8 xdata DmaTxBuffer[256];
u8 xdata DmaRxBuffer[256];

void DMA_Config(void)
{
  DMA_M2M_CFG = 0x80;     //r++ = t++
	DMA_M2M_STA = 0x00;
	DMA_M2M_AMT = 0x7f;		//ôֽn+1
	DMA_M2M_TXAH = (u8)((u16)&DmaTxBuffer >> 8);
	DMA_M2M_TXAL = (u8)((u16)&DmaTxBuffer);
	DMA_M2M_RXAH = (u8)((u16)&DmaRxBuffer >> 8);
	DMA_M2M_RXAL = (u8)((u16)&DmaRxBuffer);
	DMA_M2M_CR = 0xc0;
}

void M2M_DMA_Interrupt(void) interrupt 13
{
	if (DMA_M2M_STA & 0x01)	//
	{
		DMA_M2M_STA &= ~0x01;
		DmaFlag = 1;
	}
}


void main()
{
	u16 i;
	DmaFlag = 0;
	WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
  EAXFR = 1; //չĴ(XFR)ʹ
  CKCON = 0; //߷XRAMٶ
	
	MCU_init();
	
	for(i=0; i<256; i++)
	{
		DmaTxBuffer[i] = i; 
		DmaRxBuffer[i] = 0;
	}
	
	UART1_init();
	printf("DMA is ready\r\n");
	DMA_Config();
	
	EA=1;
	
	while(1)
	{
		if(DmaFlag)
		{
			DmaFlag = 0;
			for(i=0; i<256; i++)
			{
				printf("%02X ", DmaRxBuffer[i]);
				if((i & 0x0f) == 0x0f)
					printf("\r\n");
			}
		}
	}
}



